package com.xxl.job.admin.controller.resolver;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.xxl.job.admin.core.util.JacksonUtil;
import com.xxl.job.core.biz.model.ReturnT;
import java.io.IOException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Component;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.method.HandlerMethod;
import org.springframework.web.servlet.HandlerExceptionResolver;
import org.springframework.web.servlet.ModelAndView;

@Component
public class WebExceptionResolver implements HandlerExceptionResolver {
  private static transient Logger logger = LoggerFactory.getLogger(com.xxl.job.admin.controller.resolver.WebExceptionResolver.class);
  
  public ModelAndView resolveException(HttpServletRequest request, HttpServletResponse response, Object handler, Exception ex) {
    if (!(ex instanceof com.xxl.job.admin.core.exception.XxlJobException))
      logger.error("WebExceptionResolver:{}", ex); 
    boolean isJson = false;
    if (handler instanceof HandlerMethod) {
      HandlerMethod method = (HandlerMethod)handler;
      ResponseBody responseBody = (ResponseBody)method.getMethodAnnotation(ResponseBody.class);
      if (responseBody != null)
        isJson = true; 
    } 
    ReturnT<String> errorResult = new ReturnT(500, ex.toString().replaceAll("\n", "<br/>"));
    ModelAndView mv = new ModelAndView();
    if (isJson) {
      try {
        response.setContentType("application/json;charset=utf-8");
        response.getWriter().print(JacksonUtil.writeValueAsString(errorResult));
      } catch (IOException e) {
        logger.error(e.getMessage(), e);
      } 
      return mv;
    } 
    mv.addObject("exceptionMsg", errorResult.getMsg());
    mv.setViewName("/common/common.exception");
    return mv;
  }
}
